/*
 * <%= @warning %>
 *
 * Copyright (C) 2017 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#pragma once

#include "WebPreferencesDefaultValues.h"

<%- for @pref in @preferences do -%>
<%-   if @pref.condition -%>
#if <%= @pref.condition %>
<%-   end -%>
<%-   if @pref.defaultValues.size() == 1 -%>
#define DEFAULT_VALUE_FOR_<%= @pref.name %> <%= @pref.defaultValues['default'] %>
<%-   else -%>
<%-     @pref.defaultValues.each_with_index do |(key, value), index| -%>
<%-       if index == 0 -%>
#if <%= key %>
<%-       elsif index != @pref.defaultValues.size() - 1 -%>
#elif <%= key %>
<%-       else -%>
#else
<%-       end -%>
#define DEFAULT_VALUE_FOR_<%= @pref.name %> <%= value %>
<%-     end -%>
#endif
<%-   end -%>
<%-   if @pref.condition -%>
#endif
<%-   end -%>
<%- end -%>

// macro(KeyUpper, KeyLower, TypeNameUpper, TypeName, DefaultValue, HumanReadableName, HumanReadableDescription)

#define FOR_EACH_WEBKIT_PREFERENCE(macro) \
<%- for @pref in @exposedPreferencesNotDebug do -%>
    macro(<%= @pref.name %>, <%= @pref.nameLower %>, <%= @pref.typeUpper %>, <%= @pref.type %>, DEFAULT_VALUE_FOR_<%= @pref.name %>, <%= @pref.humanReadableName %>, <%= @pref.humanReadableDescription %>) \
<%- end -%>
    \


// Debug Preferences

#define FOR_EACH_WEBKIT_DEBUG_PREFERENCE(macro) \
<%- for @pref in @exposedPreferencesDebug do -%>
    macro(<%= @pref.name %>, <%= @pref.nameLower %>, <%= @pref.typeUpper %>, <%= @pref.type %>, DEFAULT_VALUE_FOR_<%= @pref.name %>, <%= @pref.humanReadableName %>, <%= @pref.humanReadableDescription %>) \
<%- end -%>
    \

// Internal Debug Features

#define FOR_EACH_WEBKIT_INTERNAL_DEBUG_FEATURE_PREFERENCE(macro) \
<%- for @pref in @exposedInternalFeatures do -%>
    macro(<%= @pref.name %>, <%= @pref.nameLower %>, Bool, bool, DEFAULT_VALUE_FOR_<%= @pref.name %>, <%= @pref.humanReadableName %>, <%= @pref.humanReadableDescription %>) \
<%- end -%>
   \

// Experimental Features

#define FOR_EACH_WEBKIT_EXPERIMENTAL_FEATURE_PREFERENCE(macro) \
<%- for @pref in @exposedExperimentalFeatures do -%>
    macro(<%= @pref.name %>, <%= @pref.nameLower %>, Bool, bool, DEFAULT_VALUE_FOR_<%= @pref.name %>, <%= @pref.humanReadableName %>, <%= @pref.humanReadableDescription %>) \
<%- end -%>
    \

